#include<bits/stdc++.h>

using namespace std;

typedef long long LL;

const int N = 3e5 + 10;

struct Edge {
	int to , nxt;
} E[N << 1];

int n , tot;
int x[N] , y[N] , head[N] , mx[N] , sz[N];

template <typename T> inline void chkmax(T &x , T y) { x = max(x , y); }
template <typename T> inline void chkmin(T &x , T y) { x = min(x , y); }
template <typename T> inline void read(T &x) {
	T f = 1; x = 0;
	char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -f;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + c - '0';
	x *= f;
}

namespace solver1 {
	int ans , leftsize , rightsize;
	inline int getsize(int u , int fa) {
		int ret = 1;
		for (int i = head[u]; i; i = E[i].nxt) 
			if (E[i].to != fa) ret += getsize(E[i].to , u);
		return ret;
	}
	inline void work(int u , int fa , int all)  {
		sz[u] = 1; mx[u] = 0;
		for (int i = head[u]; i; i = E[i].nxt) {
			int v = E[i].to;
			if (v == fa) continue;
			work(v , u , all);
			sz[u] += sz[v];
			chkmax(mx[u] , sz[v]);
		}
		chkmax(mx[u] , all - sz[u]);
		if (mx[u] <= all / 2) ans += u;
		return;
	}
	inline void solve() {
		ans = 0;
		for (int i = 1; i < n; ++i) {
			for (int j = 1; j <= n; ++j) 
				sz[j] = mx[j] = 0;
			leftsize = getsize(x[i] , y[i]) , rightsize = getsize(y[i] , x[i]);
			work(x[i] , y[i] , leftsize); work(y[i] , x[i] , rightsize);
		}		
		printf("%d\n" , ans);
	}
} ;

inline void addedge(int u , int v) {
	E[++tot] = (Edge){v , head[u]};
	head[u] = tot;
}

int deg[N];

inline bool Ischain() {
	for (int i = 1; i <= n; ++i)
		deg[i] = 0;
	for (int i = 1; i < n; ++i) ++deg[x[i]] , ++deg[y[i]];
	int f1 = 1 , f2 = 0;
	for (int i = 1; i <= n; ++i) f1 &= (deg[i] <= 2);
	for (int i = 1; i <= n; ++i) f2 += (deg[i] == 1);
	return (f2 == 2) && f1;		
}

int perm[N];

namespace solver2 {
	int rt;
	inline int get_centroid(int l , int r) {
		if ((r - l) & 1) return perm[(l + r) / 2] + perm[(l + r) / 2 + 1];
		else return perm[(l + r) / 2];
	}
	inline void solve() {
		for (int i = 1; i <= n; ++i)
			if (deg[i] == 1) rt = i;
		int now = rt , pref = 0 , cnt = 0;
		while (true) {
			bool hasFound = false;
			perm[++cnt] = now;
			for (int i = head[now]; i; i = E[i].nxt) {
				if (E[i].to != pref) {
					hasFound = true;
					pref = now;
					now = E[i].to;
					break;
				}
			}
			if (!hasFound) break;
		}
		LL ans = 0;
		for (int i = 1; i < n; ++i) 
			ans += (LL)get_centroid(1 , i) + (LL)get_centroid(i + 1 , n);
		printf("%lld\n" , ans);
	}
} ;

int main() {
	
	freopen("centroid.in" , "r" , stdin);
	freopen("centroid.out" , "w" , stdout);
	
	int T;
	read(T);
	while (T--) {
		read(n);
		for (int i = 1; i <= n; ++i) head[i] = 0;
		for (int i = 1; i <= tot; ++i) E[i].to = E[i].nxt = 0;
		tot = 0;
		for (int i = 1; i < n; ++i) {
			read(x[i]); read(y[i]);
			addedge(x[i] , y[i]); addedge(y[i] , x[i]);
		}
		if (n <= 2000) {
			solver1 :: solve();
			continue;
		}	
		if (Ischain()) {
			solver2 :: solve();
			continue;
		} 
		solver1 :: solve();
		continue;
	}
	
	return 0;
}

