#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <stack>
#include <queue>
#include <ctime>
#include <map>

#define submit

using std::cin;
using std::cout;
using std::endl;

const long long mod = 998244353;

template <typename T>
void read(T& x)
{
    x = 0;
    char c = getchar();
    for (; !isdigit(c); c = getchar());
    for (; isdigit(c); x = x * 10 + (c ^ 48), c = getchar());
}

struct Edge
{
    int u, v, nxt, ban;
    
    Edge(int u = 0, int v = 0, int nxt = 0): u(u), v(v), nxt(nxt), ban(0) { }
};

int T, n, cntEdge, st, Size;
int head[1000010], size[1000010], vis[1000010], dep[1000010];
Edge edge[1000010];

void addEdge(int u, int v)
{
    edge[++cntEdge] = Edge(u, v, head[u]); head[u] = cntEdge;
    edge[++cntEdge] = Edge(v, u, head[v]); head[v] = cntEdge;
}

void getDep(int x, int fr)
{
    dep[x] = dep[fr] + 1;
    for (int i = head[x]; i; i = edge[i].nxt)
    {
        int v = edge[i].v;
        if (v == fr)
            continue;
        getDep(v, x);
    }
}

void getSize(int x, int fr)
{
    for (int i = head[x]; i; i = edge[i].nxt)
    {
        if (edge[i].ban)
            continue;
        int v = edge[i].v;
        if (v == fr)
            continue;
        getSize(v, x);
        size[x] += size[v];
    }
    ++size[x];
}

int dfs(int x, int fr)
{
    if (Size - size[x] > Size / 2)
        return 0;
    int maxSize = 0, r = 0;
    for (int i = head[x]; i; i = edge[i].nxt)
    {
        if (edge[i].ban)
            continue;
        int v = edge[i].v;
        if (v == fr)
            continue;
        r += dfs(v, x);
        maxSize = std::max(maxSize, size[v]);
    }
    if (maxSize <= Size / 2)
        r += x;
    return r;
}

int main()
{
#ifdef submit
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
#endif
    for (read(T); T; --T)
    {
        memset(dep, 0, sizeof dep);
        memset(edge, 0, sizeof edge);
        memset(head, 0, sizeof head);
        memset(vis, 0, sizeof vis);
        memset(size, 0, sizeof size);
        cntEdge = 0;
        read(n);
        for (int i = 1; i < n; ++i)
        {
            int u = 0, v = 0;
            read(u); read(v);
            addEdge(u, v);
        }
        getDep(1, 1);
        long long ans = 0;
        for (int i = 1; i < n; ++i)
        {
            memset(size, 0, sizeof size);
            edge[i * 2 - 1].ban = edge[i * 2].ban = 1;
            
            getSize(1, 1);
            
            if (dep[edge[i * 2].u] > dep[edge[i * 2].v])
                st = edge[i * 2].u;
            else
                st = edge[i * 2].v;
            
            getSize(st, st);
            
            Size = size[1];
            
            ans += dfs(1, 1);
            
            Size = size[st];
            
            ans += dfs(st, st);
            
            edge[i * 2 - 1].ban = edge[i * 2].ban = 0;
        }
        cout << ans << endl;
    }
    return 0;
}
