#include <bits/stdc++.h>

#define redirect(name)	(					\
		freopen(name ".in", "r", stdin),	\
		freopen(name ".out", "w", stdout)	\
	)

using namespace std;

struct EDGE {
	int to, value, next_edge; 
};

int heads[300000 + 2];
EDGE edges[2 * 300000 + 2];
int nCurEdgesCount = 1;

void ClearEdges(void) {
	nCurEdgesCount = 1;
	memset(heads, 0, sizeof heads);
}

void AddEdge(int from, int to, int value) {
	nCurEdgesCount++;
	edges[nCurEdgesCount].to = to;
	edges[nCurEdgesCount].value = value;
	edges[nCurEdgesCount].next_edge = heads[from];
	heads[from] = nCurEdgesCount;
}

int n;

bool bVisit[300000 + 2];

unsigned int GetChainLength(int nIn) {
	/*
	int nAns = 0;
	if (bVisit[nIn])
		return 0;
	bVisit[nIn] = true;
	for (int i = heads[nIn]; i != 0; i = edges[i].next_edge) {
		//nAns = max(nAns, GetChainLength(edges[i].to) + 1);
	}
	bVisit[nIn] = false;
	return nAns;
	*/
	unsigned int nAns = 0;
	if (bVisit[nIn])
		return 0;
	
RestartCycle:
	bVisit[nIn] = true;
	for (int i = heads[nIn]; i != 0; i = edges[i].next_edge) {
		if (!bVisit[edges[i].to]) {
			nIn = edges[i].to;
			nAns++;
			goto RestartCycle;
		}
	}
	
	return nAns;
}

unsigned int nResultTemp;

void WalkChain_inner(int nIn, int nSteps) {
	if (bVisit[nIn])
		return;
	
RestartCycle:
	if (nSteps == 0) {
		nResultTemp = nIn;
		return;
	}
	
	bVisit[nIn] = true;
	
	for (int i = heads[nIn]; i != 0; i = edges[i].next_edge) {
		//WalkChain_inner(edges[i].to, nSteps - 1);
		if (!bVisit[edges[i].to]) {
			nIn = edges[i].to;
			nSteps--;
			goto RestartCycle;
		}
	}
}

unsigned int WalkChain(int nIn, int nSteps) {
	WalkChain_inner(nIn, nSteps);
	return nResultTemp;
}

unsigned int solve(void) {
	unsigned int nAns = 0;
	
	for (int nCurEdge = 2; nCurEdge <= nCurEdgesCount; nCurEdge += 2) {
		// Cut this edge
		int nDest1 = edges[nCurEdge].to;
		int nDest2 = edges[nCurEdge ^ 1].to;
		unsigned int nLen1, nLen2;
		unsigned int nTmp1, nTmp2; 
		
		bVisit[nDest2] = true;
		nLen1 = GetChainLength(nDest1);
		memset(bVisit, 0, sizeof bVisit);
		
		bVisit[nDest1] = true;
		nLen2 = GetChainLength(nDest2);
		memset(bVisit, 0, sizeof bVisit);
		
		//printf("Len is %d and %d.\n", nLen1, nLen2);
		
		// --------------------
		
		bVisit[nDest2] = true;
		if (nLen1 & 1)
			nAns += WalkChain(nDest1, nLen1 >> 1);
		else
			nAns += WalkChain(nDest1, nLen1 >> 1) + WalkChain(nDest1, (nLen1 >> 1) - 1);
		/*
		nTmp1 = WalkChain(nDest1, (nLen1 >> 1) - 1);
		bVisit[nTmp1] = true;
		if (nLen1 & 1)
			nAns += WalkChain(nTmp1, 1);
		else
			nAns += WalkChain(nTmp1, 1) + nTmp1;
		*/
		memset(bVisit, 0, sizeof bVisit);
		
		bVisit[nDest1] = true;
		if (nLen2 & 1)
			nAns += WalkChain(nDest2, nLen2 >> 1);
		else
			nAns += WalkChain(nDest2, nLen2 >> 1) + WalkChain(nDest2, (nLen2 >> 1) - 1);
		/*
		nTmp1 = WalkChain(nDest2, (nLen2 >> 1) - 1);
		bVisit[nTmp1] = true;
		if (nLen1 & 1)
			nAns += WalkChain(nTmp1, 1);
		else
			nAns += WalkChain(nTmp1, 1) + nTmp1;
		*/
		memset(bVisit, 0, sizeof bVisit);
	}
	
	return nAns;
}

void MAIN(void) {
	int t;
	
	scanf("%d", &t);
	for (int nTimes = 0; nTimes < t; nTimes++) {
		scanf("%d", &n);
		for (int i = 1; i <= n - 1; i++) {
			int a, b;
			scanf("%d%d", &a, &b);
			AddEdge(a, b, 0);
			AddEdge(b, a, 0);
		}
		
		cout << solve() << endl;
		
		ClearEdges();
	}
}

int main(void) {
#if 1
	redirect("centroid");
#endif
	MAIN();
	return 0;
}

