#include <cassert>
#include <cstdio>
#include <cstring>
#include <cctype>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0)
#endif

#ifndef DEBUG
static char buf[1 << 16 | 1], *ptr = buf + (1 << 16);
#define getchar() (ptr == buf + (1 << 16) ? buf[fread(buf, 1, 1 << 16, stdin)] = EOF, *((ptr = buf)++) : *(ptr++))
#endif
inline int readint() {
	int a = 0; char c = getchar(), po = 1;
	while(isspace(c)) c = getchar();
	if(c == '-') c = getchar(), po = 0;
	while(isdigit(c)) a = a * 10 + c - '0', c = getchar();
	return po ? a : -a;
}

typedef long long LL;
const int maxN = 300000 + 5;
int n, sz[maxN], dep[maxN];
int h[maxN], to[maxN * 2], nxt[maxN * 2], deg[maxN];

void link(int i, int x, int y) {
	to[i] = y; nxt[i] = h[x]; h[x] = i;
	deg[y]++;
}

void initialize() {
	n = readint();
	memset(h, 0, sizeof(h));
	memset(deg, 0, sizeof(deg));
	for(int i = 1; i <= n - 1; ++i) {
		int x = readint(), y = readint();
		link(i * 2, x, y);
		link(i * 2 + 1, y, x);
	}
}

void trav(int u, int fa) {
	sz[u] = 1;
	for(int i = h[u]; i; i = nxt[i]) if(to[i] != fa) {
		dep[to[i]] = dep[u] + 1;
		trav(to[i], u);
		sz[u] += sz[to[i]];
	}
}

int tot;
int dans = 0;
int dfs(int u, int fa) {
	int mx = 0, sz = 1;
	for(int i = h[u]; i; i = nxt[i]) if(to[i] != fa) {
		int cnt = dfs(to[i], u);
		sz += cnt;
		chmax(mx, cnt);
	}
	chmax(mx, tot - sz);
	if(mx <= tot / 2) dans += u;
	return sz;
}

int cut(int x, int y) {
	int ans = 0;
	if(dep[x] > dep[y]) swap(x, y);
	assert(dep[x] + 1 == dep[y]);
	dans = 0;
	tot = sz[y];
	int r = dfs(y, x); assert(r == tot);
	ans += dans;
	dans = 0;
	tot = n - sz[y];
	r = dfs(x, y); assert(r == tot);
	ans += dans;
	return ans;
}

LL solve() {
	// std should be calc contrib. for each node
	// but 1h is not enough for me to complete the code
	dep[1] = 1;
	trav(1, -1);
	LL ans = 0;
	for(int i = 1; i <= n - 1; ++i)
		ans += cut(to[i * 2], to[i * 2 + 1]);
	return ans;
}

bool ischain() {
	int d1 = 0;
	for(int i = 1; i <= n; ++i) {
		if(deg[i] == 1) d1++;
		else if(deg[i] != 2) return false;
	}
	return d1 == 2;
}
int p[maxN];
LL solveChain() {
	int s = -1;
	for(int i = 1; i <= n; ++i) if(deg[i] == 1) {
		s = i; break;
	}
	p[1] = s;
	for(int i = 1; i < n; ++i) {
		int u = p[i];
		for(int j = h[u]; j; j = nxt[j])
			if(to[j] != p[i - 1]) {
				p[i + 1] = to[j];
				break;
			}
	}
	eprintf("Chain: %d - ... - %d; length = %d\n", p[1], p[n], n);
//	displaya(p, 1, n);
	LL ans = 0;
	for(int i = 1; i < n; ++i) {
		ans += p[i / 2 + 1];
		if(i % 2 == 0) ans += p[i / 2];
	}
	reverse(p + 1, p + n + 1);
	for(int i = 1; i < n; ++i) {
		ans += p[i / 2 + 1];
		if(i % 2 == 0) ans += p[i / 2];
	}
	return ans;
}
#include <queue>
int w = 1;
bool isbin() {
	if(!(__builtin_popcount(n + 1) == 1)) return false;
	while((1 << w) < n) ++w;
	queue<int> q;
	memset(dep, 0, sizeof(dep));
	for(int i = 1; i <= n; ++i) if(deg[i] == 1) q.push(i), dep[i] = w;
	while(q.size()) {
		int u = q.front(); q.pop();
//		display(u);
		for(int i = h[u]; i; i = nxt[i]) {
			int v = to[i];
			if(dep[v]) {
				if(dep[v] != dep[u] - 1 && dep[v] != dep[u] + 1)
					return false;
			} else {
				dep[v] = dep[u] - 1;
				q.push(v);
			}
		}
	}
//	displaya(dep, 1, n);
	// not sure if this judgement is sufficient
	return *min_element(dep + 1, dep + n + 1) == 1;
}

LL solveBin() {
	int u = -1;
	for(int i = 1; i <= n; ++i) if(dep[i] == 1) {
		assert(u == -1); u = i;
	}
	int x = to[h[u]], y = to[nxt[h[u]]];
	eprintf("bin with %d->(%d, %d), size = %d\n", u, x, y, n);
	LL ans = u * (1LL << (w - 1)) + (x + y) * ((1LL << (w - 1)) - 1);
	for(int i = 1; i <= n; ++i) if(i != u) ans += i;
	return ans;
}

int main() {
#ifndef LOCAL
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
#endif
	int T = readint();
	while(T--) {
		initialize();
		if(ischain()) cout << solveChain() << endl;
		else if(isbin()) cout << solveBin() << endl;
		else cout << solve() << endl;
	}
	return 0;
}

