#include <cassert>
#include <cstdio>
#include <cstring>
#include <cctype>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0)
#endif

#ifndef DEBUG
static char buf[1 << 16 | 1], *ptr = buf + (1 << 16);
#define getchar() (ptr == buf + (1 << 16) ? buf[fread(buf, 1, 1 << 16, stdin)] = EOF, *((ptr = buf)++) : *(ptr++))
#endif
inline int readint() {
	int a = 0; char c = getchar(), po = 1;
	while(isspace(c)) c = getchar();
	if(c == '-') c = getchar(), po = 0;
	while(isdigit(c)) a = a * 10 + c - '0', c = getchar();
	return po ? a : -a;
}

typedef long long LL;
const int maxN = 100 + 5;
const int maxM = 2000 + 5;
const LL P = 998244353;
int n, m;
int a[maxN][maxM];
LL buc[maxN * 2], cub[maxN * 2];
LL *f = buc + maxN, *g = cub + maxN;

int main() {
#ifndef LOCAL
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
#endif
	n = readint(); m = readint();
	for(int i = 1; i <= n; ++i) {
		a[i][0] = 0;
		for(int j = 1; j <= m; ++j)
			a[i][j] = readint(),
			a[i][0] += a[i][j];
		a[i][0] %= P;
	}
	LL ans = 1;
	for(int i = 1; i <= n; ++i) ans = ans * (a[i][0] + 1) % P;
	ans--;
	eprintf("tot = %lld\n", ans);
	for(int j = 1; j <= m; ++j) {
		memset(buc, 0, sizeof(buc));
		memset(cub, 0, sizeof(cub));
		f[0] = 1;
		for(int i = 1; i <= n; ++i) {
			swap(f, g);
			fill(f - i - 2, f + i + 2, 0LL);
			LL here = a[i][j], there = (a[i][0] - a[i][j]) % P;
			for(int k = -(i - 1); k <= i - 1; ++k)
				(f[k + 1] += g[k] * here) %= P,
				(f[k - 1] += g[k] * there) %= P,
				(f[k] += g[k]) %= P;
		}
		LL dans = 0;
		for(int i = 1; i <= n; ++i) dans += f[i];
		(ans -= dans) %= P;
		eprintf("j = %d, dans = %lld\n", j, dans);
	}
	cout << ((ans % P + P) % P) << endl;
	return 0;
}

