#pragma GCC optimize("O2")
#include <cassert>
#include <cstdio>
#include <cstring>
#include <cctype>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0)
#endif

#ifndef DEBUG
static char buf[1 << 16 | 1], *ptr = buf + (1 << 16);
#define getchar() (ptr == buf + (1 << 16) ? buf[fread(buf, 1, 1 << 16, stdin)] = EOF, *((ptr = buf)++) : *(ptr++))
#endif
inline int readint() {
	int a = 0; char c = getchar(), po = 1;
	while(isspace(c)) c = getchar();
	if(c == '-') c = getchar(), po = 0;
	while(isdigit(c)) a = a * 10 + c - '0', c = getchar();
	return po ? a : -a;
}

typedef long long LL;
const int maxN = 40000000 + 5;
const int maxA = 1000000000 + 5;
int n, type;
LL a[maxN];

void initialize() {
	n = readint(); type = readint();
	if(type == 0) {
		for(int i = 1; i <= n; ++i) a[i] = readint();
	} else if(type == 1) {
		int x = readint(), y = readint(), z = readint();
		a[1] = readint(); a[2] = readint();
		int m = readint();
		for(int i = 3; i <= n; ++i)
			a[i] = (a[i - 1] * x + a[i - 2] * y + z)
				% (1ll << 30);
		int lp = 0;
		for(int j = 1; j <= m; ++j) {
			int p = readint();
			LL l = readint(), r = readint();
			for(int i = lp + 1; i <= p; ++i) {
				a[i] = a[i] % (r - l + 1) + l;
			}
			lp = p;
		}
	} else {
		assert(false);
	}
	a[0] = 0;
	for(int i = 1; i <= n; ++i) a[i] += a[i - 1];
}

template<int maxN>
struct BF {
	LL f[maxN][maxN];
	// garanteed ans <= 4e18
	// this inf > 4e18
	LL solve() {
		const LL INF = 0x3f3f3f3f3f3f3f3f;
		for(int i = 1; i <= n; ++i) {
			if(a[i] < 2.2e9) f[0][i] = a[i] * a[i];
			else f[0][i] = INF;
		}
		for(int l = 1; l <= n; ++l) {
			int p = l;
			LL best = INF;
			for(int r = l + 1; r <= n; ++r) {
				while(p - 1 >= 0 && a[r] - a[l] >= a[l] - a[p - 1])
					--p, chmin(best, f[p][l]);
				if(best < INF && a[r] - a[l] < (LL)2.2e9)
					f[l][r] = best + (a[r] - a[l]) * (a[r] - a[l]);
				else
					f[l][r] = INF;
			}
		}
		LL ans = INF;
		for(int i = 0; i < n; ++i) chmin(ans, f[i][n]);
		return ans;
	}
};



struct Big { // ans <= (4e16)^2 <= 1e40
	static const LL M = 1000000000;
	LL a[10];
	Big(LL x = 0) {
		memset(a, 0, sizeof(a));
		int i = 0;
		while(x) {
			a[i] = x % M;
			x /= M; ++i;
		}
	}
	LL& operator [](const int &idx) {
		return a[idx];
	}
	friend Big operator * (Big A, Big B) {
		Big R;
		for(int i = 0; i < 10; ++i) if(A[i])
			for(int j = 0; i + j < 10; ++j) if(B[i]) {
				R[i + j] += A[i] * B[j];
				if(R[i + j] > M)
					R[i + j + 1] += R[i + j] / M,
					R[i + j] %= M;
			}
		return R;
	}
	friend Big operator + (Big A, Big B) {
		Big R;
		for(int i = 0; i < 10; ++i) {
			R[i] += A[i] + B[i];
			if(R[i] > M)
				R[i + 1] += R[i] / M,
				R[i] %= M;
		}
		return R;
	}
	void print() {
		int i = 9;
		while(i >= 0 && a[i] == 0) --i;
		if(i == -1) printf("0\n");
		else {
			printf("%lld", a[i]);
			while(i--) {
				printf("%09lld", a[i]);
			}
			printf("\n");
		}
	}
};

int p[maxN];
inline LL qv(int i) {
	return a[i] * 2 - a[p[i]];
}

int q[maxN];
void solve() {
	int l = 0, r = 0;
	p[0] = 0; q[r++] = 0;
	for(int i = 1; i <= n; ++i) {
		while(l + 1 < r && a[i] >= qv(q[l + 1]))
			++l;
		p[i] = q[l];
		while(l < r && qv(i) <= qv(q[r - 1]))
			--r;
		q[r++] = i;
	}
	int t = n;
	Big ans(0);
	LL lastsum = (LL)4e18;
	while(t) {
		LL seg = a[t] - a[p[t]];
		ans = ans + Big(seg) * Big(seg);
		assert(seg <= lastsum); lastsum = seg;
		t = p[t];
	}
	ans.print();
}

int main() {
#ifndef LOCAL
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
#endif
	initialize();
	if(n <= 400) printf("%lld\n", (new BF<405>)->solve());
	else if(n <= 5000) printf("%lld\n", (new BF<5005>)->solve());
	else solve();
	return 0;
}

