#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define mp make_pair
#define pb push_back

const int N = 1 << 18;
const int inf = 1e9;
int n;
vector <int> g[N];
vector <pair <int, int> > E;
int mn; ll mnsum;
int siz[N];
int p[N];

void dfs0(int u, int p) {
	siz[u] = 1;
	for (int i = 0; i < g[u].size(); ++ i) {
		int v = g[u][i];
		if (v == p) continue;
		dfs0(v, u);
		siz[u] += siz[v];
	}
}

void dfs1(int u, int p, int rt) {
	int mx = 0;
	for (int i = 0; i < g[u].size(); ++ i) {
		int v = g[u][i];
		if (v == p) continue;
		dfs1(v, u, rt);
		mx = max(mx, siz[v]);
	}
	mx = max(mx, siz[rt] - siz[u]);
	if (mx < mn) {
		mn = mx;
		mnsum = u + 1;
	} else if (mx == mn) {
		mnsum += u + 1;
	}
}

bool is_chain() {
	int cnt[5];
	cnt[1] = cnt[2] = 0;
	for (int i = 0; i < n; ++ i) {
		if (g[i].size() >= 3) return 0;
		cnt[g[i].size()] ++;
	}
	return cnt[1] == 2 && cnt[2] == n - 2;
}

int cal_chain(int l, int r) {
	if ((r - l + 1) % 2) return p[(l + r) / 2] + 1;
	else return p[(l + r) / 2] + 1 + p[(l + r + 1) / 2] + 1;
}

int dep[N], dfn[N], on[N], tme;
void dfs2(int u, int p) {
	on[tme] = u; dfn[u] = tme ++; siz[u] = 1;
	for (int i = 0; i < g[u].size(); ++ i) {
		int v = g[u][i];
		if (v == p) continue;
		dep[v] = dep[u] + 1;
		dfs2(v, u);
		siz[u] += siz[v];
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T --) {
		scanf("%d", &n);
		for (int i = 0; i < n; ++ i)
			g[i].clear();
		E.clear();
		for (int i = 1; i < n; ++ i) {
			int u, v;
			scanf("%d %d", &u, &v); -- u, -- v;
			g[u].pb(v); g[v].pb(u);
			E.pb(mp(u, v));
		}
		ll ans = 0;
		if (n <= 2000) {
			for (int i = 0; i < E.size(); ++ i) {
				int u = E[i].first;
				int v = E[i].second;
				mn = inf, mnsum = 0; dfs0(v, u); dfs1(v, u, v); ans += mnsum;
				mn = inf, mnsum = 0; dfs0(u, v); dfs1(u, v, u); ans += mnsum;
			}
		} else
		if (is_chain()) {
			int s = -1, t = -1;
			for (int i = 0; i < n; ++ i) {
				if (g[i].size() == 1) {
					if (~s) t = i;
					else s = i;
				}
			}
			int prv = s, cnt = 0;
			while (s != t) {
				p[cnt ++] = s;
				int nprv = s;
				for (int i = 0; i < g[s].size(); ++ i) {
					if (g[s][i] == prv) continue;
					s = g[s][i]; break;
				}
				prv = nprv;
			}
			p[cnt ++] = t;
			for (int i = 0; i < n - 1; ++ i) {
				ans += cal_chain(0, i);
				ans += cal_chain(i + 1, n - 1);
			}
		} else
		{
			int rt;
			for (int i = 0; i < n; ++ i) {
				if (g[i].size() == 2) rt = i;
			}
			tme = 0; dep[rt] = 0; dfs2(rt, -1);
			for (int i = 0; i < E.size(); ++ i) {
				int u = E[i].first;
				int v = E[i].second;
				if (dep[u] > dep[v]) swap(dep[u], dep[v]);
				ans += rt + 1;
				for (int j = 0; j < g[rt].size(); ++ j) {
					int to = g[rt][j];
					if (to == u || to == v) continue;
					int mx = 0;
					mx = max(siz[to] / 2, n - siz[to] - siz[v]);
					if (dfn[v] >= dfn[to] && dfn[v] + siz[v] <= dfn[to] + siz[to])
						mx = max(mx, n - siz[to]);
					if (mx == n / 2) ans += to + 1;
					else if (mx < n / 2) ans += to + 1 - rt - 1;
				}
				ans += v + 1;
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
