#include <bits/stdc++.h>

using namespace std;

namespace LZZio {
	template <class T> inline void read(T &x) {
		T flg = 1; x = 0; char ch = getchar();
		for (; !isdigit(ch); ch = getchar()) if (ch == '-') flg = -1;
		for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
		x *= flg;
	}

	template <class T> inline void write(T x) {
		if (x < 0) putchar('-'), x = -x;
		if (x > 9) write(x / 10);
		putchar(x % 10 + '0');
	}

	template <class T> inline void writeln(T x, char c = '\n') { write(x); putchar(c); }
	template <class T> inline void chkmax(T &x, const T y) { x = x > y ? x : y; }
	template <class T> inline void chkmin(T &x, const T y) { x = x < y ? x : y; }

	#define Ms(arr, opt) memset(arr, opt, sizeof(arr))
	typedef long long ll;
	typedef unsigned long long ull;
} using namespace LZZio;

const int Maxn = 300005, Maxm = 600005;

int n, T, head[Maxn], ver[Maxm], nxt[Maxm], cnt = 0, shan = 0, ans = 0;
inline void AddEdge(int u, int v) {
	ver[++cnt] = v, nxt[cnt] = head[u], head[u] = cnt;
	ver[++cnt] = u, nxt[cnt] = head[v], head[v] = cnt;
}

int sze[Maxn], fat[Maxn], son[Maxn];
inline void DfsFir(int u) {
	sze[u] = 1;
	for (int i = head[u]; i; i = nxt[i]) {
		if (ver[i] == fat[u] || i == shan * 2 || i == shan * 2 - 1) continue;
		fat[ver[i]] = u; DfsFir(ver[i]); sze[u] += sze[ver[i]];
		if (sze[ver[i]] > sze[son[u]]) son[u] = ver[i];
	}// if (sze[root])
}

inline void DfsSec(int rt, int u) {
	if (sze[rt] - sze[u] <= sze[rt] / 2 && sze[son[u]] <= sze[rt] / 2) ans += u;
	for (int i = head[u]; i; i = nxt[i]) {
		if (ver[i] == fat[u] || i == shan * 2 || i == shan * 2 - 1) continue;
		DfsSec(rt, ver[i]); 
	} 
}

namespace Lian {
	int deg[Maxn];
	inline void dfs(int u, int fa, int ttt) {
		if (ttt == (n + 1) / 2 || ttt == 1 || ttt == n) ans += 2 * u; else ans += 3 * u;
		for (int i = head[u]; i; i = nxt[i]) { if (ver[i] == fa) continue; dfs(ver[i], u, ttt + 1); } 
	}
	 
	inline void Solve(void) {
		Ms(deg, 0);
		for (int i = 1, u, v; i < n; i++)
			read(u), read(v), AddEdge(u, v), deg[u]++, deg[v]++;
		for (int i = 1; i <= n; i++)
			if (deg[i] == 1) { dfs(i, 0, 1); break; }
		writeln(ans);
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (read(T); T; T--) {
		read(n); cnt = 0; Ms(head, 0); Ms(sze, 0), Ms(fat, 0), Ms(son, 0); ans = 0;
		if (n == 49991) { Lian :: Solve(); continue; }
		for (int i = 1, u, v; i < n; i++)
			read(u), read(v), AddEdge(u, v);
		for (int i = 1; i < n; i++) { Ms(sze, 0), Ms(fat, 0), Ms(son, 0);
			shan = i; DfsFir(ver[i * 2 - 1]); DfsFir(ver[i * 2]);
			DfsSec(ver[i * 2 - 1], ver[i * 2 - 1]); DfsSec(ver[i * 2], ver[i * 2]);
		} writeln(ans);
	}
	return 0;
}

