#define TASKNAME "centroid"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

const size_t N = 3e5 + 5;

struct Edge {
    int to, nxt;
    Edge() {}
    Edge(int to, int nxt) :
        to(to), nxt(nxt) {}
} e[N << 1];

int n, edge[N][2], head[N], tot;

void add_edge(int u, int v) {
    e[++tot] = Edge(v, head[u]);
    head[u] = tot;
}

namespace subtask_1 {

bool is_task() {
    return n <= 2000;
}

bool blocked[N];
int sz[N], mx[N];

int dfs1(int u, int p = 0) {
    int &ret = sz[u] = 1;
    for (int i = head[u]; i; i = e[i].nxt) {
        if (!blocked[i >> 1] && e[i].to != p) {
            ret += dfs1(e[i].to, u);
        }
    }
    return ret;
}

int dfs2(int u, int tot, int p = 0) {
    int ret = 0;
    mx[u] = tot - sz[u];
    for (int i = head[u]; i; i = e[i].nxt) {
        if (!blocked[i >> 1] && e[i].to != p) {
            ret += dfs2(e[i].to, tot, u);
            mx[u] = max(mx[u], sz[e[i].to]);
        }
    }
    // if (mx[u] <= tot / 2) cerr << u << ' ';
    return ret + (mx[u] <= tot / 2 ? u : 0);
}

void solve() {
    LL ans = 0;
    for (int i = 1; i < n; ++i) {
        blocked[i] = true;
        int u = edge[i][0], v = edge[i][1];
        int tot1 = dfs1(u), tot2 = dfs1(v);
        ans += dfs2(u, tot1);
        // cerr << ' ';
        ans += dfs2(v, tot2);
        // cerr << '\n';
        blocked[i] = false;
    }
    cout << ans << '\n';
}

}

namespace subtask_2 {

int deg[N], cnt[N];

bool is_task() {
    memset(deg, 0, sizeof deg);
    memset(cnt, 0, sizeof cnt);
    for (int i = 1; i < n; ++i) {
        int u = edge[i][0];
        int v = edge[i][1];
        ++deg[u]; ++deg[v];
    }
    for (int i = 1; i <= n; ++i) {
        ++cnt[deg[i]];
    }
    return cnt[1] == 2 && cnt[2] == n - 2;
}

int link[N];

bool ok(int id) {
    return 0 < id && id < n;
}

void solve() {
    int u, p = 0;
    for (int i = 1; i <= n; ++i) {
        if (deg[i] == 1) u = i;
    }
    int cnt = 0;
    while (u) {
        link[cnt++] = u;
        int v = 0;
        for (int i = head[u]; i; i = e[i].nxt) {
            if (e[i].to != p) {
                v = e[i].to;
                break;
            }
        }
        p = u;
        u = v;
    }
    assert(cnt == n);
    LL ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (ok(i * 2 + j)) {
                ans += link[i];
            }
        }
    }
    reverse(link, link + n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (ok(i * 2 + j)) {
                ans += link[i];
            }
        }
    }
    cout << ans << '\n';
}

}

namespace subtask_3 {

bool is_task() {
    return true;
}

const size_t V = N << 2;
#define lc(x) ((x) << 1)
#define rc(x) ((x) << 1 | 1)
int tree[V], lazy[V];

void build(int x, int tl, int tr) {
    tree[x] = lazy[x] = 0;
    if (tl + 1 == tr) {
        return;
    }
    int mid = (tl + tr) >> 1;
    build(lc(x), tl, mid);
    build(rc(x), mid, tr);
}

void pushup(int x) {
    tree[x] = max(tree[lc(x)], tree[rc(x)]);
}

void update(int x, int val) {
    tree[x] += val;
    lazy[x] += val;
}

void pushdown(int x) {
    if (lazy[x]) {
        update(lc(x), lazy[x]);
        update(rc(x), lazy[x]);
        lazy[x] = 0;
    }
}

void modify(int x, int tl, int tr, int l, int r, int val) {
    if (tl >= r || tr <= l) return;
    if (l <= tl && tr <= r) {
        return update(x, val);
    }
    pushdown(x);
    int mid = (tl + tr) >> 1;
    modify(lc(x), tl, mid, l, r, val);
    modify(rc(x), mid, tr, l, r, val);
    pushup(x);
}

int ask_value(int x, int tl, int tr, int p) {
    if (tl + 1 == tr) {
        return tree[x];
    }
    pushdown(x);
    int mid = (tl + tr) >> 1;
    if (p < mid) {
        return ask_value(lc(x), tl, mid, p);
    } else {
        return ask_value(rc(x), mid, tr, p);
    }
}

int find(int x, int tl, int tr, int val) {
    // cerr << "find " << x << ' ' << tl << ' ' << tr << ' ' << val << '\n';
    while (tl + 1 < tr) {
        pushdown(x);
        int mid = (tl + tr) >> 1;
        if (2 * tree[rc(x)] >= val) {
            x = rc(x);
            tl = mid;
        } else {
            tr = mid;
        }
    }
    return tl;
}

int query(int x, int tl, int tr, int l, int r, int val) {
    if (tl >= r || tr <= l || 2 * tree[x] < val) return -1;
    if (l <= tl && tr <= r) {
        return find(x, tl, tr, val);
    }
    pushdown(x);
    int mid = (tl + tr) >> 1;
    int ret = query(rc(x), mid, tr, l, r, val);
    if (!~ret) {
        ret = query(lc(x), tl, mid, l, r, val);
    }
    return ret;
}

int par[N], dep[N], tpos[N], tidx[N], son[N], siz[N], root[N], len[N], sst[N], sen[N];

void dfs1(int u = 1, int p = 0) {
    par[u] = p;
    dep[u] = dep[p] + 1;
    siz[u] = 1;
    son[u] = 0;
    for (int i = head[u]; i; i = e[i].nxt) {
        if (e[i].to != p) {
            int v = e[i].to;
            dfs1(v, u);
            siz[u] += siz[v];
            if (siz[v] > siz[son[u]]) {
                son[u] = v;
            }
        }
    }
}

int cur;

void dfs2(int u = 1, int p = 0) {
    if (son[p] != u) {
        for (int v = u; v; v = son[v]) {
            root[v] = u;
            tidx[tpos[v] = cur++] = v;
        }
        for (int v = u; v; v = son[v]) {
            len[v] = cur;
        }
    }
    sst[u] = cur;
    for (int i = head[u]; i; i = e[i].nxt) {
        if (e[i].to != p) {
            dfs2(e[i].to, u);
        }
    }
    sen[u] = cur;
}

void modify_link(int u, int v, int val) {
    for (; root[u] != root[v]; v = par[root[v]]) {
        if (dep[root[u]] > dep[root[v]]) swap(u, v);
        modify(1, 0, n, tpos[root[v]], tpos[v] + 1, val);
    }
    if (tpos[u] > tpos[v]) swap(u, v);
    modify(1, 0, n, tpos[u], tpos[v] + 1, val);
}

int get_ans(int l1, int r1, int l2, int r2, int val) {
    int ret = -1;
    if (!~ret && l2 < r2) {
        query(1, 0, n, l2, r2, val);
    }
    if (!~ret && l1 < r1) {
        ret = query(1, 0, n, l1, r1, val);
    }
    return ret;
}

int get_ans(int l1, int r1, int l2, int r2, int l3, int r3, int val) {
    // cerr << "========= " << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << ' ' << l3 << ' ' << r3 << ' ' << val << '\n';
    int ret = -1;
    if (!~ret && l3 < r3) {
        query(1, 0, n, l3, r3, val);
    }
    if (!~ret && l2 < r2) {
        ret = query(1, 0, n, l2, r2, val);
    }
    if (!~ret && l1 < r1) {
        ret = query(1, 0, n, l1, r1, val);
    }
    return ret;
}

void solve() {
    cur = 0;
    build(1, 0, n);
    dfs1(); dfs2();
    for (int i = 1; i <= n; ++i) {
        modify(1, 0, n, tpos[i], tpos[i] + 1, siz[i]);
    }
    LL ans = 0;
    for (int i = 2; i <= n; ++i) {
        modify_link(1, par[i], -siz[i]);
        {
            int r1 = get_ans(tpos[i], len[i], sst[i], sen[i], siz[i] + 1);
            ans += tidx[r1];
            // cerr << tidx[r1] << ' ';
            int r2 = get_ans(tpos[i], len[i], sst[i], sen[i], siz[i]);
            if (r1 != r2) {
                ans += tidx[r2];
                // cerr << tidx[r2] << ' ';
            }
            // cerr << ' ';
        } {
            int r1 = get_ans(0, tpos[i], len[i], sst[i], sen[i], n, n - siz[i] + 1);
            ans += tidx[r1];
            // cerr << tidx[r1] << ' ';
            int r2 = get_ans(0, tpos[i], len[i], sst[i], sen[i], n, n - siz[i]);
            if (r1 != r2) {
                ans += tidx[r2];
                // cerr << tidx[r2] << ' ';
            }
            // cerr << '\n';
            // cerr << "*r1 = " << r1 << '\n';
        }
        modify_link(1, par[i], siz[i]);
    }
    cout << ans << '\n';
}

}

void solve() {
    n = read();
    tot = 1;
    fill(head + 1, head + n + 1, 0);
    for (int i = 1; i < n; ++i) {
        int &u = edge[i][0] = read();
        int &v = edge[i][1] = read();
        add_edge(u, v);
        add_edge(v, u);
    }
    if (subtask_1::is_task()) {
        subtask_1::solve();
    } else if (subtask_2::is_task()) {
        subtask_2::solve();
    } else if (subtask_3::is_task()) {
        subtask_3::solve();
    }
}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    int t = read();
    while (t--) {
        solve();
    }

    return 0;
}
