#define TASKNAME "meal"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

const size_t N = 100 + 5;
const size_t M = 2e3 + 5;
const int MOD = 998244353;

void iadd(int &dp, int val) {
    dp += val;
    if (dp >= MOD) {
        dp -= MOD;
    }
}

void ladd(int &dp, LL val) {
    dp = (dp + val) % MOD;
}

void sp_add(unsigned long long &dp, unsigned long long val) {
    dp += val;
    if (dp >> 62) {
        dp %= MOD;
    }
}

int n, m, a[N][M];
int f[N];

void calc_f() {
    f[0] = 1;
    for (int i = 0; i < n; ++i) {
        int sum = 0;
        for (int j = 0; j < m; ++j) {
            iadd(sum, a[i][j]);
        }
        for (int j = i; j >= 0; --j) {
            ladd(f[j + 1], (LL) f[j] * sum);
        }
    }
}

namespace subtask_2 {

bool is_task() {
    return true;
}

int g[N << 1], sum[N];

void calc_g(int id) {
    memset(g, 0, sizeof g);
    g[N] = 1;
    for (int i = 0; i < n; ++i) {
        static unsigned long long gg[N << 1];
        for (int j = (int) N - i; j <= (int) N + i; ++j) {
            gg[j] = g[j];
        }
        gg[N - i - 1] = gg[N + i + 1] = 0;
        int coeff1 = a[i][id], coeff2 = sum[i];
        iadd(coeff2, MOD - coeff1);
        for (int j = (int) N - i; j <= (int) N + i; ++j) {
            sp_add(gg[j + 1], (unsigned long long) g[j] * coeff1);
            sp_add(gg[j - 1], (unsigned long long) g[j] * coeff2);
        }
        for (int j = (int) N - i - 1; j <= (int) N + i + 1; ++j) {
            g[j] = gg[j] % MOD;
        }
    }
}

void solve() {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            iadd(sum[i], a[i][j]);
        }
    }
    for (int i = 1; i <= n; ++i) {
        iadd(ans, f[i]);
    }
    for (int i = 0; i < m; ++i) {
        calc_g(i);
        for (int j = (int) N + 1; j <= (int) N + n; ++j) {
            iadd(ans, MOD - g[j]);
        }
    }
    cout << ans << '\n';
}

}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    n = read();
    m = read();
    for (int i = 0; i < n; ++i) {
        generate_n(a[i], m, read);
    }

    calc_f();

    if (subtask_2::is_task()) {
        subtask_2::solve();
    }
    return 0;
}
