#define TASKNAME "partition"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

int n, type;

namespace subtask_0 {

const size_t N = 5e5 + 5;

bool is_task() {
    return type == 0;
}

const size_t V = N << 2;
const LL INF = 5e18;

LL tree[V];
#define lc(x) ((x) << 1)
#define rc(x) ((x) << 1 | 1)

void prep() {
    fill(tree, tree + V, INF);
}

void push(int p, LL val) {
    int x = 1, tl = 0, tr = n + 1;
    while (true) {
        tree[x] = min(tree[x], val);
        if (tl + 1 == tr) {
            return;
        }
        int mid = (tl + tr) >> 1;
        if (p < mid) {
            x = lc(x);
            tr = mid;
        } else {
            x = rc(x);
            tl = mid;
        }
    }
}

int find_pos(LL val) {
    int x = 1, tl = 0, tr = n + 1;
    while (tl + 1 < tr) {
        int mid = (tl + tr) >> 1;
        if (tree[rc(x)] > val) {
            x = lc(x);
            tr = mid;
        } else {
            x = rc(x);
            tl = mid;
        }
    }
    return tl;
}

LL a[N], f[N], g[N], sum[N];

void solve() {
    generate_n(a + 1, n, read);
    partial_sum(a, a + n + 1, sum);

    prep();
    push(0, g[0] + sum[0]);
    for (int i = 1; i <= n; ++i) {
        int j = find_pos(sum[i]);
        g[i] = sum[i] - sum[j];
        f[i] = f[j] + g[i] * g[i];
        push(i, g[i] + sum[i]);
    }
    cout << f[n] << '\n';
}

}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    n = read();
    type = read();

    if (subtask_0::is_task()) {
        subtask_0::solve();
    }

    return 0;
}
