/*5C-053JS-00383, Code by Chtholly Nota Seniorious*/
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
#define rep(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define repn(i, n) for (int (i) = 1; (i) <= (n); (i)++)
#define lsh(x) (1 << (x))
#define lshll(x) (1LL << (x))
#define mp make_pair
#define pb push_back
const int N = 300030;
vector <int> G[N];
vector < pair <int, int> > e;
int deg[N];
int n;
namespace subtask1 {
	int st = -1, ed = -1;
	deque <int> chain;
	void dfs(int s, int cur, int fa) {
	//	cerr << "CALL DFS(" << s << "," << cur << "," << fa <<")" << endl;
		if (deg[cur] == 1 && cur != s) {
	//		cerr << cur << endl;
			ed = cur;
			return;
		}
		rep(i, (int)G[cur].size()) {
			if (G[cur][i] == fa) continue;
			chain.pb(G[cur][i]);
		//	cerr << G[cur][i] << endl;
			dfs(s, G[cur][i], cur);
		}
	}
	void prework() {
		repn(i, n) {
			if (deg[i] == 1) {
				st = i;
				break;
			}
		}
		chain.pb(st);
		dfs(st, st, -1);
		return;		
	}
	void solve() {
		st = ed = -1; chain.clear();
		prework();
		LL ans = 0;
		reverse(chain.begin(), chain.end());
		chain.push_front(-1);
		repn(i, n - 1) {	//deleting edge i, the edges are actually rearranged in some ways
			//left half
			if (i == 1) ans += chain[1];
			else if (i % 2 == 1) ans += chain[(1 + i) / 2];
			else ans += (chain[(1 + i) / 2] + chain[(1 + i) / 2 + 1]);
			//right half
		//	cerr << (i + 1 + n) / 2 << endl;
			if (i == n) ans += chain[n];
			else if ((n - i) % 2 == 1) ans += chain[(i + 1 + n) / 2];
			else ans += (chain[(i + 1 + n) / 2] + chain[(i + 1 + n) / 2 + 1]);
		}
		cout << ans << endl;
	}
}
namespace subtask2 {
	int vis[N], vis2[N];
	vector <int> subtree;
	pair <int, int> forbid;
	void dfs(int u, int fa) {
		vis[u] = true;
		subtree.pb(u);
		rep(i, (int)G[u].size()) {
			int v = G[u][i];
			if (v == fa) continue;
			if (vis[v]) continue;
			if (mp(u, v) == forbid || mp(v, u) == forbid) continue;
			dfs(v, u);
		}
	}
	int sz = 0;
	void dfs2(int s, int u, int fa) {
		vis2[u] = true;
		sz++;
		rep(i, (int)G[u].size()) {
			int v = G[u][i];
			if (v == fa || v == s) continue;
			if (vis[v]) continue;
			if (mp(u, v) == forbid || mp(v, u) == forbid) continue;
			dfs(v, u);
		}
	}
	int c1 = 0, c2 = 0;
	void findCentroid(int u) {
		//this function finds the centroid of one of the subtrees produced by deleting an edge
		dfs(u, -1);
		int k = subtree.size();
	//	rep(i, k) cout << subtree[i] << ' '; cerr << endl;
		rep(i, k) {
			sz = 0;		
			memset(vis2, 0, sizeof(vis2));
			bool bad = false;
			rep(j, k) {
				if (!vis2[subtree[j]]) sz = 0, vis2[subtree[i]] = true, dfs2(subtree[i], subtree[j], -1);
		//		cerr << "sz(" << subtree[i] << "," << subtree[j] << ")=" << sz << endl;
				if (sz > floor(k / 2.0)) {
					bad = true;
					break;
				}
			}
			if (bad) continue;
			if (!c1) c1 = subtree[i];
			else c2 = subtree[i];
		}
	}
	void solve() {
		LL ans = 0;
		memset(vis, 0, sizeof(vis));
		subtree.clear();
		rep(i, (int)e.size()) {
			forbid = mp(e[i].first, e[i].second);
			memset(vis, 0, sizeof(vis));
			repn(j, n) {
				if (!vis[j]) {
					c1 = c2 = 0;
					subtree.clear();
					findCentroid(j);
				//	cerr << "centroid is " << c1 << ' ' << c2 << endl;
					ans += c1;
					ans += c2;
				}
			}
		}
		cout << ans << endl;
	}
}
int main() {
#ifndef CHTHOLLY
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
#endif
	int T; cin >> T;
	while (T--) {
		cin >> n;
		rep(i, n + 10) G[i].clear(); e.clear();
		memset(deg, 0, sizeof(deg));
		repn(i, n - 1) {
			int u, v;
			cin >> u >> v;
			G[u].pb(v);
			G[v].pb(u);
			e.pb(mp(u, v));
			deg[u]++;
			deg[v]++;
		}
		if (n % 10 == 1) subtask1::solve();
#ifdef CHTHOLLY
	//	if (n % 10 == 5) subtask1::solve();
#endif
		else subtask2::solve();
	}
	return 0;
}

