#include<cstdio>
#include<cctype>
#include<cstring>
#define MaxN 300010
#define MaxM 600010

typedef long long LL;

struct edge {int v, nxt;} e[MaxM];

int T, n, x, y, siz[MaxN], root2, tot, head[MaxN], fa[MaxN], arr[MaxN], lasty, root;
int degree[MaxN], cnt[MaxM], Cnt, fson[10];
LL ans;
bool vis[MaxN], iscentral[MaxN], special1, special2;

inline int read() {
	int x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	return x * f;
}

void addedge(int x, int y) {
	e[++tot] = (edge) {y, head[x]};
	head[x] = tot;
}

void dfs1(int x, int del) {
	siz[x] = 1;
	vis[x] = 1;
	for (int i = head[x]; i; i = e[i].nxt) {
		if (i == del * 2 - 1 || i == del * 2) continue;
		int y = e[i].v;
		if (y != fa[x]) {
			fa[y] = x;
			dfs1(y, del);
			siz[x] += siz[y];
		}
	}
}

void dfs2(int root, int x, int del) {
	if (x != root && siz[root] - siz[x] > siz[root] / 2) iscentral[x] = 0;
	for (int i = head[x]; i; i = e[i].nxt) {
		if (i == del * 2 - 1 || i == del * 2) continue;
		int y = e[i].v;
		if (y == fa[x]) continue;
		if (siz[y] > siz[root] / 2) iscentral[x] = 0;
		dfs2(root, y, del);
	}
}

void dfs3(int x, int fa, int lr) {
	for (int i = head[x]; i; i = e[i].nxt) {
		int y = e[i].v;
		if (y == fa) continue;
		if (degree[y] == 1) ans += y + (lr ? fson[2] : fson[1]) + root;
		else ans += y + (lr ? fson[2] : fson[1]), dfs3(y, x, lr);
	} 
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	for (; T; T--) {
		memset(head, 0, sizeof head);
		memset(degree, 0, sizeof degree);
		memset(cnt, 0, sizeof cnt);
		n = read(); ans = 0; tot = 0; special1 = 1; special2 = 1;
		for (int i = 1; i < n; ++i) {
			x = read(); y = read();
			addedge(x, y);
			addedge(y, x);
			++degree[x]; ++degree[y];
			if (i != 1 && x != lasty) special1 = 0;
			lasty = y; arr[i] = x;
		}
		arr[n] = e[tot - 1].v;
		for (int i = 1; i <= n; ++i) {
			if (degree[i] > 3) {special2 = 0; break;}
			++cnt[degree[i]];
			if (degree[i] == 2) root = i;
		}
		if (cnt[2] != 1 || cnt[1] != (n + 1) / 2) special2 = 0; 
		if (special2) {
			Cnt = 0;
			for (int i = head[root]; i; i = e[i].nxt) fson[++Cnt] = e[i].v;
			ans = (fson[1] + fson[2]) * 2;
			if (n == 3) {printf("%lld\n", ans + root * 2); continue;}
			dfs3(fson[1], root, 0);
			dfs3(fson[2], root, 1);
			printf("%lld\n", ans);
			continue;
		}
		if (special1) {
			ans = 0;
			for (int i = 1; i < n; ++i) {
				if (i & 1) ans += arr[i / 2 + 1];
				else ans += arr[i / 2] + arr[i / 2 + 1];
				if ((n - i) & 1) ans += arr[(i + 1 + n) / 2];
				else ans += arr[(i + 1 + n) / 2] + arr[(i + 1 + n) / 2 + 1];
			}
			printf("%lld\n", ans);
			continue;
		}
		for (int i = 1; i < n; ++i) {
			memset(vis, 0, sizeof vis);
			memset(siz, 0, sizeof siz);
			for (int j = 1; j <= n; ++j) iscentral[j] = 1;
			for (int j = 1; j <= n; ++j) fa[j] = j;
			dfs1(1, i);
			for (int j = 2; j <= n; ++j)
				if (!vis[j]) dfs1(j, i), root2 = j;
			dfs2(1, 1, i);
			dfs2(root2, root2, i);
			for (int j = 1; j <= n; ++j)
				if (iscentral[j]) ans += j;
		}
		printf("%lld\n", ans);
	}
	return 0;
}

