#include <stdio.h>
#include <ctype.h>

typedef unsigned long long uint64;
typedef long long int64;

template<typename T> void qread(T& t) {
	t = 0;
	int symbol = 1;
	char c;
	while(!isdigit(c = getchar())) {
		if(c == '-') {
			symbol = -1;
		}
	}
	while(isdigit(c)) {
		t = t * 10 + c - '0';
		c = getchar();
	}
	t *= symbol;
}

int T, n, u[299995], v[299995], arr[299995], cnt, arr2[299995], cnt2;
bool hash[1000000], hashp[299995];
void work();
int count(int p);

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	qread(T);
	for(int i = 0; i < T; ++i) {
		qread(n);
		for(int i = 0; i < n - 1; ++i) {
			qread(u[i]);
			qread(v[i]);
		}
		work();
	}
	return 0;
}

int count(int p) {
	int res = 1;
	for(int i = 0; i < n - 1; ++i) {
		if(u[i] == p && !hashp[i]) {
			hashp[i] = true;
			res += count(v[i]);
			hashp[i] = false;
		}
		else if(v[i] == p && !hashp[i]) {
			hashp[i] = true;
			res += count(u[i]);
			hashp[i] = false;
		}
	}
	return res;
}

void dfs(int p) {
	arr[cnt++] = p;
	for(int i = 0; i < n - 1; ++i) {
		if(u[i] == p && !hashp[i]) {
			hashp[i] = true;
			dfs(v[i]);
			hashp[i] = false;
		}
		else if(v[i] == p && !hashp[i]) {
			hashp[i] = true;
			dfs(u[i]);
			hashp[i] = false;
		}
	}
}

void work() {
	int ans = 0;
	for(int i = 0; i < n - 1; ++i) {
		hashp[i] = true;
		int cu = u[i], cv = v[i];
		int cntu = count(cu), cntv = count(cv);
		dfs(cu);
		for(int j = 0; j < cnt; ++j) {
			for(int l = 0; l < n - 1; ++l) {
				if(hashp[l]) continue;
				if(u[l] == arr[j]) {
					hashp[l] = true;
					arr2[cnt2++] = l;
				}
				else if(v[l] == arr[j]) {
					hashp[l] = true;
					arr2[cnt2++] = l;
				}
			}
			bool flag = true;
			for(int l = 0; l < cnt2; ++l) {
				int tg;
				if(u[arr2[l]] == arr[j])
					tg = v[arr2[l]];
				else
					tg = u[arr2[l]];
				if(count(tg) > cntu / 2) {
					flag = false;
				}
				hashp[arr2[l]] = false;
			}
			cnt2 = 0;
			if(flag) {
				ans += arr[j];
			}
		}
		cnt = 0;
		
		dfs(cv);
		for(int j = 0; j < cnt; ++j) {
			for(int l = 0; l < n - 1; ++l) {
				if(hashp[l]) continue;
				if(u[l] == arr[j]) {
					hashp[l] = true;
					arr2[cnt2++] = l;
				}
				else if(v[l] == arr[j]) {
					hashp[l] = true;
					arr2[cnt2++] = l;
				}
			}
			bool flag = true;
			for(int l = 0; l < cnt2; ++l) {
				int tg;
				if(u[arr2[l]] == arr[j])
					tg = v[arr2[l]];
				else
					tg = u[arr2[l]];
				if(count(tg) > cntv / 2) {
					flag = false;
				}
				hashp[arr2[l]] = false;
			}
			cnt2 = 0;
			if(flag) {
				ans += arr[j];
			}
		}
		cnt = 0;
		hashp[i] = false;
	}
	printf("%d\n", ans);
}
