#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAXN = 300005;
const int INF = 0x3f3f3f3f;

int T, n;

struct Edge {
	int v, nxt;
}edge[MAXN * 2];
int head[MAXN], cnt;
int d[MAXN];

inline void AddEdge(int u, int v) {
	edge[++cnt].v = v;
	edge[cnt].nxt = head[u];
	head[u] = cnt;
}


namespace PART_BF {
	ll ans = 0;
	int size[MAXN], tot;
	int root1, root2;
	void dfs1(int u, int fa) {
		size[u] = 1;
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			if (v == fa) continue;
			dfs1(v, u);
			size[u] += size[v];
		}
	}
	void dfs2(int u, int fa) {
		int maxsize = 0;
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			if (v == fa) continue;
			dfs2(v, u);
			maxsize = max(maxsize, size[v]);
		}
		maxsize = max(maxsize, tot - size[u]);
		if (maxsize <= tot / 2) {
			if (root1 == 0) root1 = u;
			else root2 = u;
		}
	}
	
	void solve() {
		ans = 0;
		for (int u = 1; u <= n; ++u) {
			for (int i = head[u]; i; i = edge[i].nxt) {
				int v = edge[i].v;
				if (u > v) continue;
			//	cout <<"DELETED: "<< u << ' ' << v << endl;
				
				dfs1(u, v);
				tot = size[u];
				root1 = root2 = 0;
				dfs2(u, v);
				ans = ans + root1 + root2;
		//		tst[root1]++, tst[root2]++;
				
			//	cout << "R1: " << root1 << ' ' << root2 << endl;
				
				dfs1(v, u);
				tot = size[v];
				root1 = root2 = 0;
				dfs2(v, u);
				ans = ans + root1 + root2;
		//		tst[root1]++, tst[root2]++;
				
			//	cout << "R2: " << root1 << ' ' << root2 << endl;
			//	cout << "ANS: " << ans << endl;
			}
		}
		printf("%lld\n", ans);
	//	for (int i = 1; i <= n; ++i) {
	//		cout << tst[i] << ' ';
	//	}
	//	cout << ans;
	}
}

namespace PART_CHAIN {
	ll ans = 0;
	int a[MAXN], num;
	void dfs(int u, int fa) {
		a[++num] = u;
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			if (v == fa) continue;
			dfs(v, u);
		}
	}
	void solve() {
		ans = 0;
		for (int i = 1; i <= n; ++i)
			a[i] = 0;
		num = 0;
		for (int i = n; i >= 1; --i) {
			if (d[i] == 1) {
				dfs(i, 0);
				break;
			}
		}
		int pl1 = 1, pl2 = 1;
		int pr1 = 0, pr2 = 0;
		if (n & 1) {
			pr1 = (n + 1) / 2, pr2 = (n + 1) / 2 + 1;
		} else {
			pr1 = pr2 = (n / 2) + 1;
		}
		for (int i = 1; i < n; ++i) {
	//		cout << pl1 << ' ' << pl2 << endl;
	//		cout << pr1 << ' ' << pr2 << endl;
	//		cout << endl;
			if (pl1 == pl2) ans += a[pl1], pl2++;
			else ans += a[pl1] + a[pl2], pl1++;
			if (pr1 == pr2) ans += a[pr1], pr2++;
			else ans += a[pr1] + a[pr2], pr1++;
	//		cout << ans << endl << endl << endl;
		}
		printf("%lld\n", ans);
	}
}

int dpt;

namespace PART_BINARYTREE {
	int size[MAXN], root, dep[MAXN];
	ll ans;
	void dfs1(int u, int fa) {
		int maxsize = 0;
		size[u] = 1;
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			if (v == fa) continue;
			dfs1(v, u);
			size[u] += size[v];
			maxsize = max(maxsize, size[v]);
		}
		maxsize = max(maxsize, n - size[u]);
		if (maxsize <= n / 2) root = u;
	}
	void dfs2(int u, int fa) {
		dep[u] = dep[fa] + 1;
		if (dep[u] <= 2) ans += 1ll * (1ll << (dpt - 1)) * u;
		else ans += u;
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			if (v == fa) continue;
			dfs2(v, u);
		}
	}
	void solve() {
		ans = 0;
		root = 0;
		dfs1(1, 0);
		dfs2(root, 0);
		printf("%lld\n", ans);
	}
}


int main() {
//	freopen("centroid4.in", "r", stdin);
//	freopen("myans.out", "w", stdout);
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		for (int i = 1; i <= n; ++i)
			head[i] = d[i] = 0;
		cnt = 0;
		int cnt1 = 0, cnt2 = 0, cnt3 = 0;
		for (int i = 1; i < n; ++i) {
			int u, v;
			scanf("%d%d", &u, &v);
			AddEdge(u, v), AddEdge(v, u);
			d[u]++, d[v]++;
		}
		if (n <= 2000) {
			PART_BF::solve();
			continue;
		}
		for (int i = 1; i <= n; ++i)
			if (d[i] == 1) cnt1++;
			else if (d[i] == 2) cnt2++;
			else if (d[i] == 3) cnt3++;
		if (cnt1 == 2 && cnt2 == n - 2) {
			PART_CHAIN::solve();
			continue;
		}
		dpt = log2(n + 1);
		if (cnt1 == (1 << (dpt - 1)) && cnt2 == 1 && cnt1 + cnt2 + cnt3 == n) {
			PART_BINARYTREE::solve();
			continue;
		}
		PART_BF::solve();
	}
	return 0;
}
