#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<cstdlib>
#include<queue>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
//#include<ctime>
using namespace std;

typedef long long ll;

const int INF=0x3f3f3f3f;
const int MAXINT=2147483647;
const ll INFLL=0x3f3f3f3f3f3f3f3fll;
const double EPS=1e-6;
const int MAXN=300005;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

struct Edge{
	int v,id,nxt;
}e[MAXN*2];

int n,frt[MAXN],tot,idx,size[MAXN],fa[MAXN],u[MAXN],v[MAXN],deg[MAXN],a[MAXN];
ll ans;

void addedge(int u,int v,int id){
	e[++tot].v=v;
	e[tot].nxt=frt[u];
	e[tot].id=id;
	frt[u]=tot;
	e[++tot].v=u;
	e[tot].nxt=frt[v];
	e[tot].id=id;
	frt[v]=tot;
}

void dfs1(int now){
	size[now]=1;
	for (register int i=frt[now];i;i=e[i].nxt){
		if (e[i].id==idx) continue;
		if (e[i].v==fa[now]) continue;
		fa[e[i].v]=now;
		dfs1(e[i].v);
		size[now]+=size[e[i].v];
	}
}

void dfs2(int now){
	int maxsize=size[0]-size[now];
	for (register int i=frt[now];i;i=e[i].nxt){
		if (e[i].id==idx) continue;
		if (e[i].v==fa[now]) continue;
		maxsize=max(maxsize,size[e[i].v]);
	}
	if (maxsize*2<=size[0]){
		ans+=(ll)now;
	}
	for (register int i=frt[now];i;i=e[i].nxt){
		if (e[i].id==idx) continue;
		if (e[i].v==fa[now]) continue;
		dfs2(e[i].v);
	}
}

void solve1(){
	ans=0;
	for (register int i=1;i<n;++i){
		idx=i;
		memset(size,0,sizeof(size));
		memset(fa,0,sizeof(fa));
		fa[u[i]]=fa[v[i]]=0;
		dfs1(u[i]);
		dfs1(v[i]);
		/*
		for (register int i=1;i<=n;++i){
			printf("%d ",size[i]);
		}
		printf("\n");
		*/
		size[0]=size[u[i]];
		dfs2(u[i]);
		size[0]=size[v[i]];
		dfs2(v[i]);
	}
	printf("%lld\n",ans);
}

void solve2(){
	memset(a,0,sizeof(a));
	for (register int i=1;i<=n;++i){
		if (deg[i]==1) a[1]=i;
	}
	for (register int i=2;i<=n;++i){
		int x=frt[a[i-1]];
		if (e[x].v==a[i-2]) x=e[x].nxt;
		a[i]=e[x].v;
	}
	/*
	for (register int i=1;i<=n;++i){
		printf("%d ",a[i]);
	}
	printf("\n");
	*/
	ans=0;
	for (register int i=2;i<=n;++i){
		if ((i-1)%2==1){
			ans+=(ll)a[i/2];
		}
		else{
			ans+=(ll)(a[i/2]+a[(i+1)/2]);
		}
		if ((n-i+1)%2==1){
			ans+=(ll)a[i+(n-i)/2];
		}
		else{
			ans+=(ll)(a[i+(n-i)/2]+a[i+(n-i)/2+1]);
		}
	}
	printf("%lld\n",ans);
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=readu();
	while (T--){
		n=read();
		tot=1;
		memset(frt,0,sizeof(frt));
		memset(deg,0,sizeof(deg));
		bool f=true;
		for (register int i=1;i<n;++i){
			u[i]=readu();v[i]=readu();
			addedge(u[i],v[i],i);
			deg[u[i]]++;
			deg[v[i]]++;
			if (deg[u[i]]>2 || deg[v[i]]>2) f=false;
		}
		if (n<=2000){
			solve1();
		}
		else if (f){
			solve2();
		}
	}
	return 0;
}

