#include <bits/stdc++.h>
using namespace std;
typedef long long LL;

const int MAXN = 300005;
struct Edge { int to, next; } edge[MAXN << 1];
int head[MAXN], sz[MAXN], all[MAXN], T, n, tot;
void addedge(int u, int v) {
	edge[++tot] = (Edge) { v, head[u] };
	head[u] = tot;
}
int fst[MAXN], sec[MAXN];
void dfs1(int u, int fa) {
	fst[u] = sec[u] = sz[u] = 0;
	for (int i = head[u]; i; i = edge[i].next) {
		int v = edge[i].to;
		if (v == fa) continue;
		dfs1(v, u);
		sz[u] += sz[v];
		if (sz[fst[u]] < sz[v]) sec[u] = fst[u], fst[u] = v;
		else if (sz[sec[u]] < sz[v]) sec[u] = v;
		++all[sz[v]];
	}
	++sz[u];
	if (sz[fst[u]] < n - sz[u]) sec[u] = fst[u], fst[u] = -1;
	else if (sz[sec[u]] < n - sz[u]) sec[u] = -1;
}
int bit1[MAXN], bit2[MAXN], tmp[MAXN], cen, temp;
void add(int *bit, int x, int y) {
	for (; x <= n; x += x & -x) bit[x] += y;
}
int ask(int *bit, int x) {
	if (x <= 0) return 0;
	int res = 0;
	for (; x; x -= x & -x) res += bit[x];
	return res;
}
LL ans;
void dfs2(int u, int fa) {
	int f = fst[u] < 0 ? n - sz[u] : sz[fst[u]];
	int s = sec[u] < 0 ? n - sz[u] : sz[sec[u]];
	int beg = -1, iscen = 0;
	if (fa) {
		add(bit2, n - sz[u], 1);
		add(bit2, sz[u], -1);
	}
	add(bit1, sz[u], 1);
	if (f <= n / 2 && (n & 1)) {//centroid
		cen = u;
		iscen = 1;
	} else {
		if (fst[u] < 0) {
			beg = ask(bit1, n - 2 * s) - ask(bit1, 2 * f - n - 1);
			tmp[u] = all[n - 2 * s] - all[2 * f - n - 1] + ask(bit2, n - 2 * s) - ask(bit2, 2 * f - n - 1);
		} else {
			int cnt0 = ask(bit1, n - 2 * s) - ask(bit1, 2 * f - n - 1);
			dfs2(fst[u], u);
			int cnt = ask(bit1, n - 2 * s) - ask(bit1, 2 * f - n - 1) - cnt0;
			ans += (LL)cnt * u;
		}
	}
	for (int i = head[u]; i; i = edge[i].next) {
		int v = edge[i].to;
		if (v == fa || (!iscen && v == fst[u])) continue;
		dfs2(v, u);
	}
	if (fa) {
		add(bit2, n - sz[u], -1);
		add(bit2, sz[u], 1);
	}
	if (beg >= 0) {
		tmp[u] += beg - ask(bit1, n - 2 * s) + ask(bit1, 2 * f - n - 1);
		ans += (LL)tmp[u] * u;
	}
}
void dfs3(int u, int fa, int l, int r) {
	if (sz[u] >= l && sz[u] <= r) ++temp;
	for (int i = head[u]; i; i = edge[i].next) {
		int v = edge[i].to;
		if (v == fa) continue;
		dfs3(v, u, l, r);
	}
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (scanf("%d", &T); T--;) {
		memset(head, 0, sizeof(head));
		memset(sz, 0, sizeof(sz));
		memset(bit1, 0, sizeof(bit1));
		memset(tmp, 0, sizeof(tmp));
		memset(all, 0, sizeof(all));
		memset(bit2, 0, sizeof(bit2));
		ans = 0, tot = cen = 0;
		scanf("%d", &n);
		for (int i = 1; i < n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			addedge(u, v);
			addedge(v, u);
		}
		dfs1(1, 0);
		for (int i = 1; i <= n; i++)
			all[i] += all[i - 1];
		dfs2(1, 0);
		if (cen) {
			dfs1(cen, 0);
			temp = 0;
			int f = sz[fst[cen]], s = sz[sec[cen]];
			for (int j = head[cen]; j; j = edge[j].next) {
				int v = edge[j].to;
				if (v != fst[cen]) {
					dfs3(v, cen, 0, n - 2 * f);
				} else dfs3(v, cen, 2 * f - n, n - 2 * s);
			}
			ans += (LL)temp * cen;
		}
		printf("%lld\n", ans);
	}
	return 0;
}

