#include <bits/stdc++.h>
#define foreach(a, b) for (__typeof(a.begin()) b = a.begin(); b != a.end(); b++)

using namespace std;

void fileio() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
}

inline int lowbit(int x) { return x & -x; }

const int MAX_N = 3e5 + 10;

typedef long long ll;

int N, C, siz[MAX_N];
ll ans;
vector<int> edge[MAX_N], child[MAX_N];

int find_center(int x, int y = 0) {
    int sz = 1, mx = 0;
    foreach(edge[x], i) {
        if (*i == y) continue;
        int t = find_center(*i, x);
        sz += t; mx = max(mx, t);
    }
    if (sz >= N - sz && N - mx >= mx)
        C = x;
    return sz;
}

void build(int x, int y = 0) {
    siz[x] = 1;
    foreach(edge[x], i) {
        if (*i == y) continue;
        child[x].push_back(*i);
        build(*i, x);
        siz[x] += siz[*i];
    }
}

void calc_root(int x, int mx) {
    if (N - mx - siz[x] >= mx) ans += C;
    foreach(child[x], i) {
        calc_root(*i, mx);
    }
}

void init() {
    scanf("%d", &N);
    for (int i = 1; i < N; i++) {
        int a, b; scanf("%d%d", &a, &b);
        edge[a].push_back(b);
        edge[b].push_back(a);
    }
    find_center(1);
    build(C);
    int mx1 = 0, mx2 = 0;
    foreach(child[C], i) {
        if (siz[*i] >= mx1) mx2 = mx1, mx1 = siz[*i];
        else if (siz[*i] > mx2) mx2 = siz[*i];
    }
    foreach(child[C], i) {
        calc_root(*i, siz[*i] == mx1 ? mx2 : mx1);
    }
}

struct BIT {
    int v[MAX_N];

    void clear() {
        memset(v, 0, sizeof(v));
    }

    void add(int x, int y) {
        for (; x <= N; x += lowbit(x)) v[x] += y;
    }

    int query(int x) {
        x = min(max(x, 0), N);
        int y = 0;
        for (; x; x -= lowbit(x)) y += v[x];
        return y;
    }
} bit;

void recursive_add(int x, int y) {
    bit.add(siz[x], y);
    foreach(child[x], i) {
        recursive_add(*i, y);
    }
}

void solve_dfs(int x) {
    bit.add(N - siz[x], 1);
    int mx = 0;
    foreach(child[x], i) {
        mx = max(mx, siz[*i]);
    }
    ans += ll(x) * (bit.query(N - 2 * mx) - bit.query(N - 2 * siz[x] - 1));
    foreach(child[x], i) {
        solve_dfs(*i);
    }
    bit.add(N - siz[x], -1);
}

void solve() {
    foreach(child[C], i) {
        recursive_add(*i, 1);
    }
    foreach(child[C], i) {
        recursive_add(*i, -1);
        solve_dfs(*i);
        recursive_add(*i, 1);
    }
    printf("%lld\n", ans);
}

void clear() {
    C = 0; ans = 0;
    for (int i = 1; i <= N; i++) {
        edge[i].clear();
        child[i].clear();
    }
    bit.clear();
}

int main() {
    fileio();
    int T; scanf("%d", &T);
    for (int i = 1; i <= T; i++) {
        init();
        solve();
        clear();
    }
}
