#include <cstdio>
typedef long long int64;

const int VSZ = 3e6 + 7;
const int ESZ = VSZ * 2;

int n, m;

int tot, head[VSZ];
struct Edge {
	int from, to, next;
} edge[ESZ];

int fa[VSZ], size[VSZ];
int64 ans;

inline void addEdge(int x, int y) {
	edge[++tot].from = x, edge[tot].to = y;
	edge[tot].next = head[x], head[x] = tot;
}

inline void TInit() {
	tot = 0, ans = 0;
	for (register int i = 1; i <= n; i++)
		head[i] = 0;
}

inline void dfsInit() {
	for (register int i = 1; i <= n; i++)
		fa[i] = 0;
}

// С 
void dfs(int x) {
	size[x] = 1;
	for (int i = head[x]; i ; i = edge[i].next) {
		int y = edge[i].to;
		if (y == fa[x])
			continue;
		fa[y] = x;
		dfs(y);
		size[x] += size[y];
	}
}

bool isG(int x, int tot_size) {
	int limit = tot_size / 2;
	int sum = 0;
	for (register int i = head[x]; i; i = edge[i].next) {
		register int y = edge[i].to;
		if (y == fa[x])
			continue;
		if (size[y] > limit)
			return false;
		sum += size[y];
	}
	register int left = tot_size - sum - 1;
	if (left <= limit)
		return true;
	else
		return false;
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T--) {
	scanf("%d", &n), m = n - 1;
	TInit();
	for (register int i = 1; i <= m; i++) {
		register int x, y;
		scanf("%d%d", &x, &y);
		addEdge(x, y), addEdge(y, x);
	}
	for (int i = 1; i <= m; i++) {
		int p1 = edge[i*2].from, p2 = edge[i*2].to;
//		printf("del:%d-%d: ", p1, p2);
		// side1
		dfsInit(), fa[p1] = p2, dfs(p1);
		int tot_size1 = size[p1];
		if (tot_size1 == 1)
			ans += p1;
//			ans += p1, printf("%d ", p1);
		else {
			for (int j = 1; j <= n; j++)
				if (fa[j] && isG(j, tot_size1))
					ans += j;
//					ans += j, printf("%d ", j);
		}
//		printf("| ");
		// side2
		dfsInit(), fa[p2] = p1, dfs(p2);
		int tot_size2 = size[p2];
		if (tot_size2 == 1)
			ans += p2;
//			ans += p2, printf("%d ", p2);
		else {
			for (int j = 1; j <= n; j++)
				if (fa[j] && isG(j, tot_size2))
					ans += j; 
//					ans += j, printf("%d ", j);
		}
//		puts("");
	}
	printf("%lld\n", ans);
	}
	return 0;
}
