#include <bits/stdc++.h>
using namespace std;
// Fast IO start
namespace io {
	const int BUFSIZE = 1 << 20;
	char ibuf[BUFSIZE + 1], *is = ibuf, *it = ibuf;
	inline char read_char() {
		if (is == it) {
			it = (is = ibuf) + fread(ibuf, 1, BUFSIZE, stdin);
			if (is == it) return EOF;
		}
		return *is++;
	}
	template<class T>
	inline void read_int(T &x) {
		T f = 1;
		char c = read_char();
		while (!isdigit(c)) {
			if (c == '-') f = -1;
			c = read_char();
		}
		x = 0;
		while (isdigit(c)) {
			x = x * 10 + c - '0';
			c = read_char();
		}
		x *= f;
	}
}
using io::read_char;
using io::read_int;
// Fast IO end
const int N = 300005;
int n, head[N], to[N * 2], nxt[N * 2], eid, fa[N], sz[N], dgr[N];
namespace SOLVE_LIAN {
	int lian[N], tot;
	void dfs(int u, int lst) {
		lian[++tot] = u;
		for (int i = head[u]; ~i; i = nxt[i]) {
			int v = to[i];
			if (v == lst) continue;
			dfs(v, u);
		}
	}
	inline void solve() {
		tot = 0;
		for (int i = 1; i <= n; i++) if (dgr[i] == 1) {
			dfs(i, 0);
			break;
		}
		long long ans = 0;
		for (int i = 2; i <= n; i++) {
			// 1 ~ i - 1
			if (i & 1) {
				ans += lian[i / 2];
				ans += lian[i / 2 + 1];
			} else {
				ans += lian[i / 2];
			}
			// i ~ n
			if ((n - i) & 1) {
				ans += lian[(i + n) / 2];
				ans += lian[(i + n) / 2 + 1];
			} else {
				ans += lian[(i + n) / 2];
			}
		}
		printf("%lld\n", ans);
	}
}
namespace SOLVE_BT {
	int rt, ch[N][2];
	bool dfs(int u, int lst, int dep, int mxd) {
		if (dep == mxd) return false;
		int cc = 0;
		ch[u][0] = ch[u][1] = 0;
		for (int i = head[u]; ~i; i = nxt[i]) {
			int v = to[i];
			if (v == lst) continue;
			if (!dfs(v, u, dep + 1, mxd)) return false;
			cc++;
			if (cc <= 2) ch[u][cc - 1] = v;
			else return false;
		}
		if (dep == mxd - 1 && cc) return false;
		return true;
	}
	inline bool IS_TASK() {
		int mxd;
		for (mxd = 0; (1 << mxd) < n; mxd++);
		if (n + 1 != (1 << mxd)) return false;
		for (int i = 1; i <= n; i++) if (dgr[i] == 2) {
			rt = i;
			return dfs(i, 0, 0, mxd);
		}
		return false;
	}
	long long ans;
	void solve_dfs(int u, int dep, int gay) {
		if (u == rt) {
			solve_dfs(ch[u][0], dep + 1, ch[u][1]);
			solve_dfs(ch[u][1], dep + 1, ch[u][0]);
			return;
		}
		ans += u;
		if (ch[u][0]) {
			ans += gay;
			solve_dfs(ch[u][0], dep + 1, gay);
			solve_dfs(ch[u][1], dep + 1, gay);
		} else {
			ans += gay;
			ans += rt;
		}
	}
	inline void solve() {
		ans = 0;
		solve_dfs(rt, 0, 0);
		printf("%lld\n", ans);
	}
}
inline void add_edge(int u, int v) {
	to[eid] = v;
	nxt[eid] = head[u];
	head[u] = eid++;
}
void dfs(int u, int lst) {
	fa[u] = lst;
	sz[u] = 1;
	for (int i = head[u]; ~i; i = nxt[i]) {
		int v = to[i];
		if (v == lst) continue;
		dfs(v, u);
		sz[u] += sz[v];
	}
}
long long ans;
int sbsz[N];
void solve_dfs(int u, int lst, int allsz) {
	sbsz[u] = 1;
	int mx = 0;
	for (int i = head[u]; ~i; i = nxt[i]) {
		int v = to[i];
		if (v == lst) continue;
		solve_dfs(v, u, allsz);
		sbsz[u] += sbsz[v];
		mx = max(mx, sbsz[v]);
	}
	mx = max(mx, allsz - sbsz[u]);
	if (mx <= allsz / 2) ans += u;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	read_int(T);
	while (T--) {
		read_int(n);
		for (int i = 1; i <= n; i++) head[i] = -1, dgr[i] = 0;
		eid = 0;
		for (int i = 1; i < n; i++) {
			int u, v;
			read_int(u);
			read_int(v);
			add_edge(u, v);
			add_edge(v, u);
			dgr[u]++, dgr[v]++;
		}
		int mxdgr = 0;
		for (int i = 1; i <= n; i++) mxdgr = max(mxdgr, dgr[i]);
		if (mxdgr <= 2) {
			SOLVE_LIAN::solve();
			continue;
		}
		if (SOLVE_BT::IS_TASK()) {
			SOLVE_BT::solve();
			continue;
		}
		dfs(1, 0);
		ans = 0;
		for (int i = 2; i <= n; i++) {
			solve_dfs(i, fa[i], sz[i]);
			solve_dfs(fa[i], i, n - sz[i]);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
