#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

vector<int> g[300001] = {};
int n;

namespace bf {

int size[2001] = {};
int f[2001][21] = {}; 
int d[2001] = {};

void dfs(int u, int fa) {
	size[u] = 1;
	f[u][0] = fa;
	for (int i=0;i<g[u].size();i++) {
		if (g[u][i] != fa) {
			d[g[u][i]] = d[u] +1;
			dfs(g[u][i], u);
			size[u] += size[g[u][i]]; 
		}
	}
}

bool is_ancestor(int a, int b) {
	if (d[a] > d[b]) {
		return false;
	}
	int offset = d[b] - d[a];
	for (int k=20;k>=0;k--) {
		if (offset & (1 << k)) b = f[b][k];
	}
	return a==b;
}

int ans = 0;
void dfs2(int u, int fa, int father_size, int total_size) {
	bool flag = father_size <= total_size / 2;
	for (int i=0;i<g[u].size();i++) {
		if (g[u][i] != fa) {
			dfs2(g[u][i], u, total_size - size[g[u][i]], total_size);
			if (size[g[u][i]] > total_size / 2) flag = false;
		}
	}
	if (flag) {
		ans += u;
	} 
}

void dfs3(int u, int fa, int avoid, int father_size, int total_size) {
	
	bool flag = father_size <= total_size / 2;
	for (int i=0;i<g[u].size();i++) {
		if (g[u][i] != fa && g[u][i] != avoid) {
			const bool anc = is_ancestor(g[u][i], avoid);
			dfs3(g[u][i], u, avoid, size[1] - size[g[u][i]] - (anc ? 0 : size[avoid]), total_size);
			if (size[g[u][i]] - (anc ? size[avoid] : 0) > total_size / 2) flag = false;
		}
	}
	if (flag) {
		ans += u;
	}
}

void dfs4(int u, int fa) {
	for (int i=0;i<g[u].size();i++) {
		if (g[u][i] != fa) {
			dfs2(g[u][i], u, 0, size[g[u][i]]);
			dfs3(1, -1, g[u][i], 0, size[1] - size[g[u][i]]);
			dfs4(g[u][i], u);
		}
	}
}

void solve() {
	ans = 0;
	dfs(1, -1);
	for (int k=1;k<=20;k++)
		for (int i=1;i<=n;i++) {
			f[i][k] = f[f[i][k-1]][k-1];
		}
	dfs4(1, -1);
	cout << ans << endl;
}

}

namespace chain {

vector<int> chain;

void dfs(int u, int fa) {
	chain.push_back(u);
	for (int i=0;i<g[u].size();i++) {
		if (g[u][i] != fa) dfs(g[u][i], u);
	}
}

void solve() {
	chain.clear();
	for (int i=1;i<=n;i++) {
		if (g[i].size() == 1) {
			dfs(i, -1);
			break;
		}
	}
	ll ans = 0;
	for (int i=1;i<chain.size();i++) {
		if (i%2) {
			ans += chain[(i-1)/2];
		} else {
			ans += chain[i/2] + chain[i/2-1];
		}
	}
	reverse(chain.begin(), chain.end());
	for (int i=1;i<chain.size();i++) {
		if (i%2) {
			ans += chain[(i-1)/2];
		} else {
			ans += chain[i/2] + chain[i/2-1];
		}
	}
	cout << ans << endl;
}

}

void solve() {
	cin>>n;
	
	int u, v;
	for (int i=1;i<n;i++) {
		cin>>u>>v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	
	if (n <= 1999) bf::solve();
	else {
		chain::solve();
	}
	for (int i=1;i<=n;i++) g[i].clear();
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	ios::sync_with_stdio(false); cin.tie(NULL);
	int T; cin>>T;
	while(T--) solve();

	return 0;
}


