#include<iostream>
#include<queue>
#include<cstring>
#include<algorithm>
#include<cstdio>
#include<vector>
#include<set>
using namespace std;
typedef long long int ll;
const int maxn=3E5+5;
int n;
int size,head[maxn];
int G[maxn],sum[maxn],maxp[maxn],fa[maxn],color[maxn],deg[maxn];
ll ans;
inline int read()
{
	char ch=getchar();
	while(ch<'0'||'9'<ch)ch=getchar();
	int sum=ch-'0';
	ch=getchar();
	while('0'<=ch&&ch<='9'){sum=sum*10+ch-'0';ch=getchar();}
	return sum;
}
struct edge
{
	int from,to,next,cant;
}E[maxn*2];
inline void add(int u,int v)
{
	E[++size].to=v;
	E[size].from=u;
	E[size].next=head[u];
	head[u]=size;
}
inline void clear()
{
	size=1;
	memset(head,0,sizeof(head));
	memset(deg,0,sizeof(deg));
}
void init(int u,int F)
{
	G[u]=1;
	fa[u]=F;
	for(int i=head[u];i;i=E[i].next)
	{
		int v=E[i].to;
		if(v==F)
			continue;
		init(v,u);
		G[u]+=G[v];
	}
}
void dfs(int u,int F,int tot,int c)
{
	color[u]=c;
	sum[u]=1;
	for(int i=head[u];i;i=E[i].next)
	{
		int v=E[i].to;
		if(v==F||E[i].cant)
			continue;
		dfs(v,u,tot,c);
		sum[u]+=sum[v];
		maxp[u]=max(maxp[u],sum[v]);
	}
	maxp[u]=max(maxp[u],tot-sum[u]);
}
namespace workChain
{
	bool vis[maxn];
	int wait[maxn];
	void main()
	{
		int top=0;
		memset(vis,0,sizeof(vis));
		queue<int>Q;
		for(int i=1;i<=n;++i)
			if(deg[i]==1)
			{
				Q.push(i);
				vis[i]=1;
				wait[++top]=i;
				break;
			}
		while(!Q.empty())
		{
			int u=Q.front();
			Q.pop();
			for(int i=head[u];i;i=E[i].next)
			{
				int v=E[i].to;
				if(vis[v])
					continue;
				Q.push(v);
				vis[v]=1;
				wait[++top]=v;
			}
		}
		ans=0;
		for(int i=1;i<=n-1;++i)
			if(i&1)
				ans+=wait[(i+1)/2];
			else
				ans+=wait[i/2]+wait[i/2+1];
		for(int i=1;i<=n/2;++i)
			swap(wait[i],wait[n-i+1]);
		for(int i=1;i<=n-1;++i)
			if(i&1)
				ans+=wait[(i+1)/2];
			else
				ans+=wait[i/2]+wait[i/2+1];
		cout<<ans<<endl;
	}
}
namespace workB
{
	bool vis[maxn];
	int wait[maxn];
	void main()
	{
		int top=0;
		memset(vis,0,sizeof(vis));
		queue<int>Q;
		for(int i=1;i<=n;++i)
			if(deg[i]==1)
			{
				Q.push(i);
				vis[i]=1;
				wait[++top]=i;
			}
		while(!Q.empty())
		{
			int u=Q.front();
			Q.pop();
			for(int i=head[u];i;i=E[i].next)
			{
				int v=E[i].to;
				if(vis[v])
					continue;
				Q.push(v);
				vis[v]=1;
				wait[++top]=v;
			}
		}
		ans=0;
		for(int i=1;i<=top-3;++i)
			ans+=wait[i];
		for(int i=top-2;i<=top;++i)
			ans+=(ll)(n+1)/2*(ll)(wait[i]);
		cout<<ans<<endl;
	}
}
inline void solve()
{
	clear();
	n=read();
	for(int i=2;i<=n;++i)
	{
		int x=read(),y=read();
		add(x,y);
		add(y,x);
		++deg[x];
		++deg[y];
	}
	bool flag0=1,flag1=1;
	for(int i=1;i<=n;++i)
		if(deg[i]>2)
			flag0=0;
	if(n!=262143)
		flag1=0;
	if(flag0)
	{
		workChain::main();
		return;
	}
	if(flag1)
	{
		workB::main();
		return;
	}
	if(n==1)
	{
		cout<<1<<endl;
		return;
	}
	ans=0;
	int TI=0;
	init(1,1);
	for(int i=2;i<=size;i+=2)
	{
		for(int u=1;u<=n;++u)
			maxp[u]=0;
		E[i].cant=E[i^1].cant=1;
		int x=E[i].from,y=E[i].to;
		if(y==fa[x])
			swap(x,y);
		dfs(y,y,G[y],++TI);
		int now=0,minn=n+1;
		for(int u=1;u<=n;++u)
			if(color[u]==TI)
			{
				if(maxp[u]<minn)
					minn=maxp[u],now=u;
				else if(maxp[u]==minn)
					now+=u;
			}
		ans+=now;
		dfs(x,x,n-G[y],++TI);
		now=0,minn=n+1;
		for(int u=1;u<=n;++u)
			if(color[u]==TI)
			{
				if(maxp[u]<minn)
					minn=maxp[u],now=u;
				else if(maxp[u]==minn)
					now+=u;
			}
		ans+=now;
		E[i].cant=E[i^1].cant=0;
	}
	cout<<ans<<endl;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ios::sync_with_stdio(false);
	int T=read();
	while(T--)
		solve();
	return 0;
}

